//============================================================================
// Name        : memoryLeaks.cpp
// Author      : Malcodigo
// Version     :
// Copyright   : 
//============================================================================

#include <stdio.h>
#include <stdlib.h>
//Para sleep
#include <unistd.h>

#include "CMemoryLeaks/CMemoryLeaks.h"

void *hilo(void *pVoid);

char *creaMemoryChar(unsigned int puiSize);

void *hilo(void *pVoid)
{
 char *lpchrPru;
 CMemoryLeaks *lpContMem;


 puts("hilo->Cominezo hilo");

 puts("hilo->Instancio el contador de memoria");
 lpContMem=CMemoryLeaks::getInstance();

 puts("hilo->Creo espacio de memoria");
 lpchrPru=new char[6];
 lpContMem->crear((UINT_PTR)lpchrPru,__FILE__,__func__,__LINE__-1,"pchrPru=new char[6];");

 puts("hilo->Espero 5 segundos");
 sleep(5);


 //para que no haya errores descomentar
 lpContMem->liberar((UINT_PTR)lpchrPru);
 delete []lpchrPru;
 lpchrPru=NULL;

 puts("hilo-> fin");
 return NULL;
}



int main()
{
 pthread_t lpthreadHilo;
 CMemoryLeaks *lpContMemMain;
 int *lpiPru;
 char *lpchrPru;
 std::string *lpstrError;

 puts("Main->Lanzo el hilo 1");
 pthread_create(&lpthreadHilo,NULL,hilo,NULL);

 puts("Main->Instancio el contador de memoria");
 lpContMemMain=CMemoryLeaks::getInstance();

 puts("Main->Creo espacio de memoria");
 lpiPru=new int;
 lpContMemMain->crear((UINT_PTR)lpiPru,__FILE__,__func__,__LINE__-1,"lpiPru=new int;");
 //para que no haya errores descomentar
 //lpContMemMain->liberar((UINT_PTR)lpiPru);
 //delete lpiPru;


 puts("Main-> espero ha que el hilo finalize");
 pthread_join(lpthreadHilo,NULL);


 puts("Main-> creaMemoryChar");
 lpchrPru=creaMemoryChar(10);
 lpContMemMain->crear((UINT_PTR)lpchrPru,__FILE__,__func__,__LINE__-1,
		      "creaMemoryChar(10);");
 //para que no haya errores descomentar
 //lpContMemMain->liberar((UINT_PTR)lpchrPru);
 //delete []lpchrPru;

 puts("Main-> finalizo el contador de memoria");
 lpstrError=CMemoryLeaks::finalizar();

 if (lpstrError!=NULL)
 {
  puts("Main-> no se ha gestionado la memoria correctamente");
  puts(lpstrError->c_str());
  delete lpstrError;
 }




 puts("Main-> Fin");
 return 0;
}

char *creaMemoryChar(unsigned int puiSize)
{
 return new char[puiSize];
}
